function X = cm(bx,hrcolor,reg_param)

method = init_option(0,'method','mse');

At = reshape(bx, [size(bx, 1) * size(bx, 2), size(bx, 3)]);
Bt = reshape(hrcolor, [size(hrcolor, 1) * size(hrcolor, 2), size(hrcolor, 3)]);

Tt = [];
eval(['Tt = solve_T_' method '(At, Bt);']);

BB = reshape(hrcolor, [size(hrcolor, 1) * size(hrcolor, 2), size(hrcolor, 3)]);
AA = BB * Tt;

X = reshape(AA, [size(hrcolor,1) size(hrcolor,2) size(bx,3)]);

    function Tt = solve_T_mse(At, Bt)
        Tt = pinv(Bt' * Bt) * (Bt' * At);
    end

    function Tt = solve_T_mse_regularization(At, Bt)   
        [~, s, ~] = svd(Bt, 0);
        d = diag(s);
        lamda = d(1) * reg_param; %1e-6 is regularization param
        Tt = pinv(Bt' * Bt + lamda * eye(size(Bt, 2))) * (Bt' * At);
    end

    function val = init_option(options, name, default_val)
        if isfield(options, name), val = options.(name); else val = default_val; end
    end

end